<?php
namespace Suprimentos\Entities;

class Prazopgtaf extends Base\Prazopgtaf
{
    /**
     * Salva prazo e percentual no banco
     * @static
     * @param $nrorg
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     * @param $nrdiaspgtoaf
     * @param $vrpercpgtoaf
     * @param $dtinclusao
     * @return \Suprimentos\Entities\Prazopgtaf
     */
    public static function inserePrazoPercentual($nrdiaspgtoaf, $vrpercpgtoaf, $cdfildest, $cdfillanc, $nrautoforn, $nrorg, $dtinclusao) {
        /* @var $obj_prazopgtaf Prazopgtaf*/
        $obj_prazopgtaf = new Prazopgtaf();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        try {
            $obj_prazopgtaf->setNrdiaspgtoaf($nrdiaspgtoaf);
            $obj_prazopgtaf->setVrpercpgtoaf($vrpercpgtoaf);
            $obj_prazopgtaf->setCdfildest($cdfildest);
            $obj_prazopgtaf->setCdfillanc($cdfillanc);
            $obj_prazopgtaf->setNrautoforn($nrautoforn);
            $obj_prazopgtaf->setNrorg($nrorg);
            $obj_prazopgtaf->setDtinclusao($dtinclusao);
            $obj_prazopgtaf->setDtultatu($dtinclusao);
            $obj_prazopgtaf->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());
            $obj_prazopgtaf->setCdoperultatu(\Geral\Util\Ambiente::getCdOperador());
            $obj_prazopgtaf->setNrorginclusao($nrorg);
            $obj_prazopgtaf->setNrorgultatu($nrorg);

            $obj_prazopgtaf->persist();
            $connection->flush();
        } catch (\Exception $e) {
            $connection->rollback();
            \Geral\Util\TratamentoDeMensagens::exibirMensagens($e);
        }
    }

    /**
     * Atualiza percentual no banco
     * @static
     * @param $nrorg
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     * @param $nrdiaspgtoaf
     * @param $vrpercpgtoaf
     * @return \Suprimentos\Entities\Prazopgtaf
     */
    public static function atualizaPrazoPercentual($nrdiaspgtoaf, $vrpercpgtoaf, $cdfildest, $cdfillanc, $nrautoforn, $nrorg) {
        /* @var $obj_prazopgtaf Prazopgtaf*/
        $obj_prazopgtaf = Prazopgtaf::getObjectByWhere('NRDIASPGTOAF = ? AND CDFILDEST = ? AND CDFILLANC = ? AND NRAUTOFORN = ? AND NRORG = ?', array($nrdiaspgtoaf, $cdfildest, $cdfillanc, $nrautoforn, $nrorg));
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        try {
            $obj_prazopgtaf->setVrpercpgtoaf($vrpercpgtoaf);
            $obj_prazopgtaf->persist();
            $connection->flush();
        } catch (\Exception $e) {
            $connection->rollback();
            \Geral\Util\TratamentoDeMensagens::exibirMensagens($e);
        }
    }
}