/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8150_SUPSTPO.sql

Descrio:
Consolidao de AFs no OL.

Criao:
10/08/2005 Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE PROCEDURE CONSOLIDA_AF
                     (P_DTAUTOFORN   IN ITMAPURPREC.DTENTRAPUT%TYPE,
                      P_CDCENTCMP    IN ITMAPURPREC.CDCENTITMAP%TYPE,
                      P_NRSEQAPUR    IN VARCHAR2,
                      P_CDFILLANC    IN AUTOFORNE.CDFILLANC%TYPE,
                      P_NRSEQAPURCON OUT ITMAPURPREC.NRSEQITMAP%TYPE,
                      P_CDOPERLANC   IN OPERADOR.CDOPERADOR%TYPE,
                      P_NRSEQCONS    IN ITMAPURPREC.NRSEQITMAP%TYPE)

IS
   V_REGANTERIOR       VARCHAR2(255);
   V_ITEMANTERIOR      VARCHAR2(255);
   V_ANTCDFILDEST      VARCHAR2(4);
   V_ANTCDFILLANC      VARCHAR2(4);
   V_ANTCDFORNECED     VARCHAR2(21);
   V_ANTCDEMPRESA      VARCHAR2(2);
   V_ANTCODIGO         VARCHAR2(10);
   V_ITEMAUTF_ANTERIOR VARCHAR2(255);
   V_ITEMAUTF_ANT      VARCHAR2(255);   
   V_SUMPERCPZO        PRAZOPGTAF.VRPERCPGTOAF%TYPE;
   V_QTPROGENTAF       ITEMAUTF.QTPROGENTAF%TYPE;
   V_IDUTEMPENHAF      PARASUPRI.IDUTEMPENHAF%TYPE;
   V_CDINSCESTA        VARCHAR2(16);
   V_DTPROGENTAF       DATE;
   V_VRPRODUTO         NUMBER;
   V_VRIMPOSTO         NUMBER;
   V_NOVOCODIGO        VARCHAR2(20);
   V_VRDESCONTO        NUMBER;
   V_VRARREDEMPE       PRODFORNCOMP.VRARREDEMPE%TYPE;

   V_CDPERIENTR   PERFILPROD.CDPERIENTR%TYPE;
   V_NRDIASEG     NUMBER;
   V_NRLIMISEGCAD LIMISEGPROD.NRLIMISEGU%TYPE;
   V_DTNEWENTAF   DATE;

   V_DTINIAPUPREC DATE;
   V_DTFINAPUPREC DATE;
   V_DTENTREGA    DATE;
   V_IDUTILDTPROC VARCHAR2(1);
   V_DTPROCESS    DATE;
   V_NRAUTOFORN   AUTOFORNE.NRAUTOFORN%TYPE;
   V_NRSEQAPUR    ITMAPURPREC.NRSEQITMAP%TYPE;
   V_COUNT_APUR   NUMBER;
   V_IDSEPAFIMP   PARASUPRI.IDSEPAFIMP%TYPE;
   V_COUNT_AF     NUMBER;
   V_NRAUTFOROL   AUTOFORNE.NRAUTOFORN%TYPE;   
BEGIN
/* - Operador Logstico
     Gera AF Consolidante  */

   V_REGANTERIOR       := ' ';
   V_ITEMANTERIOR      := ' ';
   V_ANTCDFILDEST      := ' ';
   V_ANTCODIGO         := ' ';
   V_ANTCDEMPRESA      := ' ';
   V_ANTCDFORNECED     := ' ';
   V_ITEMAUTF_ANTERIOR := ' ';
   V_ITEMAUTF_ANT      := ' ';
   V_SUMPERCPZO        := 0;

   SELECT
      NVL(MAX(IDSEPAFIMP), 'N')
   INTO
      V_IDSEPAFIMP /*Gera AF's Separadas de Acordo com o Imposto*/
   FROM
      PARASUPRI
   WHERE
      CDFILIAL = P_CDCENTCMP;

   SELECT
      MAX(IDUTILDTPROC)
   INTO
      V_IDUTILDTPROC
   FROM
     PARAMGERAL;

   SELECT
      MIN(DTINIAPUPREC),
      MAX(DTFINAPUPREC)
   INTO
      V_DTINIAPUPREC,
      V_DTFINAPUPREC
   FROM
      APURPRECO,
      LISTA
   WHERE
      CDFILCENTCMP  = P_CDCENTCMP AND
      LISTA.NRLISTA = P_NRSEQAPUR AND
      LISTA.CDLISTA = NRAPURPREC;

   IF P_NRSEQCONS IS NOT NULL THEN
      V_NRSEQAPUR := P_NRSEQCONS;
   ELSE
      SELECT
         COUNT(*)
      INTO
         V_COUNT_APUR
      FROM
         LISTA
      WHERE
         LISTA.NRLISTA = P_NRSEQAPUR;

      IF V_COUNT_APUR > 1 THEN
         NOVO_CODIGO('APURPRECO'||P_CDCENTCMP, V_NOVOCODIGO, 1);
         V_NRSEQAPUR := SUBSTR(V_NOVOCODIGO, 11, 10);
         INSERT INTO
            APURPRECO
           (CDFILCENTCMP, NRAPURPREC, DTINIAPUPREC,
            DTFINAPUPREC, IDSITAPUPREC, DTAPURPREC,CDOPERADOR, CDFILLANC)
          VALUES
           (P_CDCENTCMP, V_NRSEQAPUR, V_DTINIAPUPREC,
            V_DTFINAPUPREC, '5', SYSDATE, P_CDOPERLANC, P_CDFILLANC);
      ELSE
         SELECT
            MAX(NRAPURPREC)
         INTO
            V_NRSEQAPUR
         FROM
            APURPRECO,
            LISTA
         WHERE
            CDFILCENTCMP  = P_CDCENTCMP AND
            LISTA.NRLISTA = P_NRSEQAPUR AND
            LISTA.CDLISTA = NRAPURPREC;
      END IF;
   END IF;

   /* Calcula calendrio de compras para as periodicidades que ainda no possuem */
   FOR C_PERIODNCALC IN
    (SELECT
       DISTINCT
       PARAMPRODSUP.CDFILIOPELOG,
       PRODUTO.CDARVPROD,
       TO_DATE('01/'||TO_CHAR(ITEMAUTF.DTPROGENTAF,'MM/YYYY'), 'DD/MM/YYYY') AS DTENTRAPUT
     FROM
       PARAMPRODSUP,
       ITEMAUTF,
       (SELECT
           AUTOFORNE.CDFORNECED,
           AUTOFORNE.CDFILDEST,
           AUTOFORNE.NRAUTOFORN,
           AUTOFORNE.CDFILLANC
        FROM
           AUTOFORNE,
           LISTA L
        WHERE
           L.NRLISTA = P_NRSEQAPUR           AND
           L.CDLISTA = AUTOFORNE.NRSEQAPURAF
        UNION ALL
        SELECT DISTINCT
           AUTOFORNE.CDFORNECED,
           AUTOFORNE.CDFILDEST,
           AUTOFORNE.NRAUTOFORN,
           AUTOFORNE.CDFILLANC
        FROM
           AUTOFORNE, ITEMAUTF
        WHERE
           AUTOFORNE.CDFILDEST   = ITEMAUTF.CDFILDEST  AND
           AUTOFORNE.CDFILLANC   = ITEMAUTF.CDFILLANC  AND
           AUTOFORNE.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN AND
           AUTOFORNE.IDAFOPERLOG = '2'                 AND
           AUTOFORNE.NRSEQAPURAF IS NULL               AND
           ITEMAUTF.DTPROGENTAF BETWEEN V_DTINIAPUPREC AND V_DTFINAPUPREC
           ) AUTOFORNE,
       RELACPRODOL,
       PRODUTO
     WHERE
       ITEMAUTF.CDFILDEST      = AUTOFORNE.CDFILDEST     AND
       ITEMAUTF.CDFILLANC      = AUTOFORNE.CDFILLANC     AND
       ITEMAUTF.NRAUTOFORN     = AUTOFORNE.NRAUTOFORN    AND
       ITEMAUTF.CDFILDESTOL    IS NULL                   AND
       RELACPRODOL.CDPRARVORIG = ITEMAUTF.CDPRODUTO      AND
       RELACPRODOL.CDMARCA     = ITEMAUTF.CDMARCA        AND
       PARAMPRODSUP.CDFILIAL   = ITEMAUTF.CDFILDEST      AND
       PARAMPRODSUP.CDPRODUTO  = RELACPRODOL.CDPRARVORIG AND
       PARAMPRODSUP.CDFILIOPELOG IS NOT NULL             AND
       RELACPRODOL.CDPRODARVOL = PRODUTO.CDPRODUTO       AND
       NOT EXISTS(SELECT 1
                  FROM REFORFIL
                  WHERE REFORFIL.CDFILIAL = PARAMPRODSUP.CDFILIOPELOG
                    AND REFORFIL.CDFORNECED = AUTOFORNE.CDFORNECED
                    AND REFORFIL.CDPERIENTR IS NULL)
     )
   LOOP
      /* - Verifica a data de processamento para a filial informada ------------ */

      IF V_IDUTILDTPROC <> 'S' THEN
         V_DTPROCESS := TRUNC(SYSDATE);
      ELSE
         SELECT
            NVL(MAX(DTPROCESSA), TRUNC(SYSDATE))
         INTO
            V_DTPROCESS
         FROM
            PARAMFILIAL
         WHERE
            CDFILIAL = C_PERIODNCALC.CDFILIOPELOG;
      END IF;
      SELECT
         MAX(PERFILPROD.CDPERIENTR)
      INTO
         V_CDPERIENTR
      FROM
         PERFILPROD,
         PRODUTO
      WHERE
         (PERFILPROD.CDPRODUTO = PRODUTO.CDPRODUTO)           AND
         (PERFILPROD.CDFILIAL  = C_PERIODNCALC.CDFILIOPELOG)  AND
         (PRODUTO.CDARVPROD = (SELECT
                                  MAX(B.CDARVPROD)
                               FROM
                                  PERFILPROD A,
                                  PRODUTO B
                               WHERE
                                  (A.CDPRODUTO = B.CDPRODUTO) AND
                                  (A.CDFILIAL = C_PERIODNCALC.CDFILIOPELOG) AND
                                  (INSTR(C_PERIODNCALC.CDARVPROD, B.CDARVPROD) = 1)));
      IF V_CDPERIENTR IS NOT NULL THEN
         CALC_DATA_ENTR_MES(C_PERIODNCALC.CDFILIOPELOG,
                            V_CDPERIENTR,
                            C_PERIODNCALC.DTENTRAPUT,
                            1,
                            V_DTPROCESS);
      END IF;
      COMMIT;
   END LOOP;

   FOR C_OPLOG IN
    (SELECT
       DISTINCT
       PARAMPRODSUP.CDFILIOPELOG,
       AUTOFORNE.CDOPERADOR,
       AUTOFORNE.CDFORNECED,
       DECODE(FORNECEDOR.IDGERAFDTENT,
              'S', CARREGA_PERIFORN_FUN(PARAMPRODSUP.CDFILIOPELOG, AUTOFORNE.CDFORNECED, ITEMAUTF.DTPROGENTAF),
              NULL ) AS DTENTRAPUT,
       DECODE(V_IDSEPAFIMP,
              'S', SUBSTR(SEPARA_AF_IMPOSTO_FUN(ITEMAUTF.CDFILDEST,
                                                ITEMAUTF.CDFILLANC,
                                                ITEMAUTF.NRAUTOFORN,
                                                ITEMAUTF.CDPRODUTO,
                                                ITEMAUTF.CDMARCA,
                                                ITEMAUTF.DTPROGENTAF), 1, 2),
              'X') AS SEPARA_IMPOSTO,
       AUTOFORNE.CDEMPRESA,
       AUTOFORNE.IDTPFORPGTAF,
       AUTOFORNE.CDTIPCOB,
       AUTOFORNE.IDTIPOFRETAF,
       AUTOFORNE.CDFORMPGTO,
       AUTOFORNE.NRPARCPGTOAF,
       AUTOFORNE.NRDIAPGFIXAF,
       AUTOFORNE.IDUTDIAPGTAF,
       AUTOFORNE.IDTIPOEMITAF,
       AUTOFORNE.IDAFPRODWEB,
       PRAZOPGTAF.NRDIASPGTOAF,
       PRAZOPGTAF.VRPERCPGTOAF,
       AUTOFORNE.CDFILDEST,
       AUTOFORNE.NRAUTOFORN
     FROM
       PARAMPRODSUP,
       PRAZOPGTAF,
       ITEMAUTF,
       (SELECT
           AUTOFORNE.CDOPERADOR,
           AUTOFORNE.CDFORNECED,
           AUTOFORNE.CDEMPRESA,
           AUTOFORNE.IDTPFORPGTAF,
           AUTOFORNE.CDTIPCOB,
           AUTOFORNE.IDTIPOFRETAF,
           AUTOFORNE.CDFORMPGTO,
           AUTOFORNE.NRPARCPGTOAF,
           AUTOFORNE.NRDIAPGFIXAF,
           AUTOFORNE.IDUTDIAPGTAF,
           AUTOFORNE.IDTIPOEMITAF,
           AUTOFORNE.IDAFPRODWEB,
           AUTOFORNE.CDFILDEST,
           AUTOFORNE.NRAUTOFORN,
           AUTOFORNE.CDFILLANC
        FROM
           AUTOFORNE,
           LISTA L
        WHERE
           L.NRLISTA = P_NRSEQAPUR           AND
           L.CDLISTA = AUTOFORNE.NRSEQAPURAF
        UNION ALL
        SELECT DISTINCT
           AUTOFORNE.CDOPERADOR,
           AUTOFORNE.CDFORNECED,
           AUTOFORNE.CDEMPRESA,
           AUTOFORNE.IDTPFORPGTAF,
           AUTOFORNE.CDTIPCOB,
           AUTOFORNE.IDTIPOFRETAF,
           AUTOFORNE.CDFORMPGTO,
           AUTOFORNE.NRPARCPGTOAF,
           AUTOFORNE.NRDIAPGFIXAF,
           AUTOFORNE.IDUTDIAPGTAF,
           AUTOFORNE.IDTIPOEMITAF,
           AUTOFORNE.IDAFPRODWEB,
           AUTOFORNE.CDFILDEST,
           AUTOFORNE.NRAUTOFORN,
           AUTOFORNE.CDFILLANC
        FROM
           AUTOFORNE, ITEMAUTF
        WHERE
           AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST   AND
           AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC   AND
           AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN  AND
           AUTOFORNE.NRSEQAPURAF IS NULL               AND
           AUTOFORNE.IDAFOPERLOG = '2'                 AND
           ITEMAUTF.DTPROGENTAF BETWEEN V_DTINIAPUPREC AND V_DTFINAPUPREC
           ) AUTOFORNE,
       RELACPRODOL,
       FORNECEDOR
     WHERE
       AUTOFORNE.CDFORNECED    = FORNECEDOR.CDFORNECED    AND
       ITEMAUTF.CDFILDEST      = AUTOFORNE.CDFILDEST      AND
       ITEMAUTF.CDFILLANC      = AUTOFORNE.CDFILLANC      AND
       ITEMAUTF.NRAUTOFORN     = AUTOFORNE.NRAUTOFORN     AND
       ITEMAUTF.CDFILDESTOL    IS NULL                    AND
       AUTOFORNE.CDFILDEST     = PRAZOPGTAF.CDFILDEST(+)  AND
       AUTOFORNE.CDFILLANC     = PRAZOPGTAF.CDFILLANC(+)  AND
       AUTOFORNE.NRAUTOFORN    = PRAZOPGTAF.NRAUTOFORN(+) AND
       RELACPRODOL.CDPRARVORIG = ITEMAUTF.CDPRODUTO       AND
       RELACPRODOL.CDMARCA     = ITEMAUTF.CDMARCA         AND
       PARAMPRODSUP.CDFILIAL   = ITEMAUTF.CDFILDEST       AND
       PARAMPRODSUP.CDPRODUTO  = RELACPRODOL.CDPRARVORIG  AND
       PARAMPRODSUP.CDFILIOPELOG IS NOT NULL              AND
       NOT EXISTS(SELECT 1
                  FROM REFORFIL
                  WHERE REFORFIL.CDFILIAL   = PARAMPRODSUP.CDFILIOPELOG
                     AND REFORFIL.CDFORNECED = AUTOFORNE.CDFORNECED
                     AND REFORFIL.CDPERIENTR IS NULL)
     )
   LOOP
     V_SUMPERCPZO := V_SUMPERCPZO + NVL(C_OPLOG.VRPERCPGTOAF,0);

     IF (V_REGANTERIOR <>  C_OPLOG.CDFILIOPELOG   ||
                           C_OPLOG.CDOPERADOR     ||
                           C_OPLOG.CDFORNECED     ||
                           C_OPLOG.CDEMPRESA      ||
                           C_OPLOG.SEPARA_IMPOSTO ||
                           C_OPLOG.IDTPFORPGTAF   ||
                           C_OPLOG.CDTIPCOB       ||
                           C_OPLOG.IDTIPOFRETAF   ||
                           C_OPLOG.CDFORMPGTO     ||
                           C_OPLOG.NRPARCPGTOAF   ||
                           C_OPLOG.NRDIAPGFIXAF   ||
                           C_OPLOG.IDUTDIAPGTAF   ||
                           C_OPLOG.IDTIPOEMITAF   ||
                           C_OPLOG.IDAFPRODWEB    ||
                           C_OPLOG.DTENTRAPUT) OR (V_SUMPERCPZO > 100) THEN

      IF V_ANTCODIGO <> ' ' THEN

         -- GERA-PARCELAS
         UPDATE ITEMAUTF
         SET ITEMAUTF.NRPARCITMAF = (SELECT
                                        LPAD(TO_CHAR(COUNT(DISTINCT ITEM.DTPROGENTAF)),2,'0')
                                     FROM ITEMAUTF ITEM
                                     WHERE
                                      (ITEM.CDFILDEST   = V_ANTCDFILDEST) AND
                                      (ITEM.CDFILLANC   = P_CDFILLANC)    AND
                                      (ITEM.NRAUTOFORN  = V_ANTCODIGO)    AND
                                      (ITEM.DTPROGENTAF <= ITEMAUTF.DTPROGENTAF))
         WHERE
            (ITEMAUTF.CDFILDEST  = V_ANTCDFILDEST) AND
            (ITEMAUTF.CDFILLANC  = P_CDFILLANC) AND
            (ITEMAUTF.NRAUTOFORN = V_ANTCODIGO);

         SELECT MIN(CDINSCESTA) INTO V_CDINSCESTA
         FROM INSCRESTAD
         WHERE (CDEMPRESA = V_ANTCDEMPRESA);

         SELECT MIN(DTPROGENTAF) INTO V_DTPROGENTAF
         FROM ITEMAUTF
         WHERE (CDFILDEST  = V_ANTCDFILDEST)  AND
               (CDFILLANC  = V_ANTCDFILLANC)  AND
               (NRAUTOFORN = V_ANTCODIGO);

         IMPOSTO_ITEMAF(V_ANTCDEMPRESA,
                        V_CDINSCESTA,
                        V_ANTCDFORNECED,
                        V_ANTCDFILDEST,
                        P_CDFILLANC,
                        V_ANTCODIGO,
                        V_DTPROGENTAF);

         -- qryValor_AF

         SELECT
            SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
            SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * NVL(ITEMAUTF.VRPERDESAF, 0)) / 100)
            INTO V_VRPRODUTO, V_VRDESCONTO
         FROM
            ITEMAUTF
         WHERE
            (ITEMAUTF.CDFILDEST  = V_ANTCDFILDEST) AND
            (ITEMAUTF.CDFILLANC  = V_ANTCDFILLANC) AND
            (ITEMAUTF.NRAUTOFORN = V_ANTCODIGO);

         SELECT
            NVL(SUM(IMPITMAF.VRADIMPAF), 0) INTO V_VRIMPOSTO
         FROM
            IMPITMAF,
            ITEMAUTF
         WHERE
            (IMPITMAF.CDFILDEST   = V_ANTCDFILDEST)       AND
            (IMPITMAF.CDFILLANC   = V_ANTCDFILLANC)       AND
            (IMPITMAF.NRAUTOFORN  = V_ANTCODIGO)          AND
            (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)   AND
            (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)   AND
            (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)  AND
            (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)   AND
            (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)     AND
            (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF);

         UPDATE AUTOFORNE
         SET VRTOTALAF = V_VRPRODUTO - V_VRDESCONTO + V_VRIMPOSTO
         WHERE
            (CDFILDEST   = V_ANTCDFILDEST) AND
            (CDFILLANC   = V_ANTCDFILLANC) AND
            (NRAUTOFORN  = V_ANTCODIGO);
       END IF;

       V_SUMPERCPZO  := NVL(C_OPLOG.VRPERCPGTOAF,0);

       V_ITEMANTERIOR := C_OPLOG.CDFILIOPELOG   ||
                         C_OPLOG.CDOPERADOR     ||
                         C_OPLOG.CDFORNECED     ||
                         C_OPLOG.CDEMPRESA      ||
                         C_OPLOG.SEPARA_IMPOSTO ||
                         C_OPLOG.IDTPFORPGTAF   ||
                         C_OPLOG.CDTIPCOB       ||
                         C_OPLOG.IDTIPOFRETAF   ||
                         C_OPLOG.CDFORMPGTO     ||
                         C_OPLOG.NRPARCPGTOAF   ||
                         C_OPLOG.NRDIAPGFIXAF   ||
                         C_OPLOG.IDUTDIAPGTAF   ||
                         C_OPLOG.IDTIPOEMITAF   ||
                         C_OPLOG.IDAFPRODWEB;

       V_REGANTERIOR := C_OPLOG.CDFILIOPELOG   ||
                        C_OPLOG.CDOPERADOR     ||
                        C_OPLOG.CDFORNECED     ||
                        C_OPLOG.CDEMPRESA      ||
                        C_OPLOG.SEPARA_IMPOSTO ||
                        C_OPLOG.IDTPFORPGTAF   ||
                        C_OPLOG.CDTIPCOB       ||
                        C_OPLOG.IDTIPOFRETAF   ||
                        C_OPLOG.CDFORMPGTO     ||
                        C_OPLOG.NRPARCPGTOAF   ||
                        C_OPLOG.NRDIAPGFIXAF   ||
                        C_OPLOG.IDUTDIAPGTAF   ||
                        C_OPLOG.IDTIPOEMITAF   ||
                        C_OPLOG.IDAFPRODWEB    ||
                        C_OPLOG.DTENTRAPUT;

       NOVO_CODIGO('AUTOFORNE'||C_OPLOG.CDFILIOPELOG || P_CDFILLANC, V_NOVOCODIGO, 1);
       V_NOVOCODIGO := SUBSTR(V_NOVOCODIGO, 11, 10);

       V_ANTCDFILDEST  := C_OPLOG.CDFILIOPELOG;
       V_ANTCODIGO     := V_NOVOCODIGO;
       V_ANTCDEMPRESA  := C_OPLOG.CDEMPRESA;
       V_ANTCDFORNECED := C_OPLOG.CDFORNECED;

       INSERT INTO AUTOFORNE
        (CDFILDEST,    CDFILLANC,    NRAUTOFORN,   CDOPERADOR,   DTAUTOFORN,
         IDTPFORPGTAF, IDTIPOEMITAF, IDTIPOFRETAF, NRPARCPGTOAF, NRDIAPGFIXAF,
         IDUTDIAPGTAF, CDTIPCOB,     CDEMPRESA,    CDFORMPGTO,   CDFORNECED,
         NRSEQAPURAF,  IDAFPRODWEB,  IDAFOPERLOG,  IDTIPOLANCAF, IDBAIXAAF,
         IDAFCONS)
       VALUES
        (C_OPLOG.CDFILIOPELOG, P_CDFILLANC,          V_NOVOCODIGO,         C_OPLOG.CDOPERADOR,         P_DTAUTOFORN,
         C_OPLOG.IDTPFORPGTAF, C_OPLOG.IDTIPOEMITAF, C_OPLOG.IDTIPOFRETAF, C_OPLOG.NRPARCPGTOAF, C_OPLOG.NRDIAPGFIXAF,
         C_OPLOG.IDUTDIAPGTAF, C_OPLOG.CDTIPCOB,     C_OPLOG.CDEMPRESA,    C_OPLOG.CDFORMPGTO,   C_OPLOG.CDFORNECED,
         V_NRSEQAPUR,          C_OPLOG.IDAFPRODWEB,  '1',                  'A',                  '6',
         'N');

       IF C_OPLOG.NRDIASPGTOAF IS NOT NULL THEN
         INSERT INTO PRAZOPGTAF
          (CDFILDEST, CDFILLANC, NRAUTOFORN,  NRDIASPGTOAF, VRPERCPGTOAF)
         VALUES
          (C_OPLOG.CDFILIOPELOG, P_CDFILLANC, V_NOVOCODIGO,
           C_OPLOG.NRDIASPGTOAF, C_OPLOG.VRPERCPGTOAF);
       END IF;
     END IF;

     FOR C_ITOPLOG IN
      (SELECT
         PARASUPRI.CDMARCA,    RELACPRODOL.CDPRODARVOL AS CDPRODUTO,
         ITEMAUTF.DTPROGENTAF, NULL AS CDSEGMARCA,
         ITEMAUTF.VRPREUNIAF,  ITEMAUTF.VRPERDESAF,
         ITEMAUTF.TXOBSITMAF,  ITEMAUTF.VRDESCITMAF,
         ITEMAUTF.QTPROGENTAF, PRODUTO.CDARVPROD,
         ITEMAUTF.CDPRODUTO AS CDPRODITEMAF,
         ITEMAUTF.CDMARCA AS CDMARCAITEMAF,
         DECODE(V_IDSEPAFIMP,
                'S', SUBSTR(SEPARA_AF_IMPOSTO_FUN(ITEMAUTF.CDFILDEST,
                                                  ITEMAUTF.CDFILLANC,
                                                  ITEMAUTF.NRAUTOFORN,
                                                  ITEMAUTF.CDPRODUTO,
                                                  ITEMAUTF.CDMARCA,
                                                  ITEMAUTF.DTPROGENTAF), 1, 2),
                'X') AS SEPARA_IMPOSTO_IT
       FROM
         AUTOFORNE, ITEMAUTF, RELACPRODOL, PARASUPRI, PRODUTO
       WHERE
         ITEMAUTF.CDFILDEST   = C_OPLOG.CDFILDEST       AND
         ITEMAUTF.CDFILLANC   = P_CDFILLANC             AND
         ITEMAUTF.NRAUTOFORN  = C_OPLOG.NRAUTOFORN      AND
         ITEMAUTF.CDPRODUTO   = RELACPRODOL.CDPRARVORIG AND
         ITEMAUTF.CDMARCA     = RELACPRODOL.CDMARCA     AND
         PARASUPRI.CDFILIAL   = P_CDCENTCMP             AND
         PARASUPRI.CDMARCA IS NOT NULL                  AND
         RELACPRODOL.CDPRODARVOL = PRODUTO.CDPRODUTO    AND
         AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST      AND
         AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC      AND
         AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN     AND
         ITEMAUTF.CDFILDESTOL IS NULL
       ORDER BY
         RELACPRODOL.CDPRODARVOL,
         ITEMAUTF.DTPROGENTAF,
         AUTOFORNE.CDFILLANC,
         AUTOFORNE.NRSEQAPURAF DESC)

     LOOP
        IF C_ITOPLOG.SEPARA_IMPOSTO_IT = C_OPLOG.SEPARA_IMPOSTO THEN
           SELECT
              MAX(PERFILPROD.CDPERIENTR)
           INTO
              V_CDPERIENTR
           FROM
              PERFILPROD,
              PRODUTO
           WHERE
              (PERFILPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
              (PERFILPROD.CDFILIAL  = C_OPLOG.CDFILIOPELOG)  AND
              (PRODUTO.CDARVPROD = (SELECT
                                       MAX(B.CDARVPROD)
                                    FROM
                                       PERFILPROD A,
                                       PRODUTO B
                                    WHERE
                                       (A.CDPRODUTO = B.CDPRODUTO) AND
                                       (A.CDFILIAL = C_OPLOG.CDFILIOPELOG) AND
                                       (INSTR(C_ITOPLOG.CDARVPROD, B.CDARVPROD) = 1)));

           LIMISEGU(C_OPLOG.CDFILIOPELOG, C_ITOPLOG.CDARVPROD, C_ITOPLOG.DTPROGENTAF, V_CDPERIENTR, V_NRDIASEG, V_NRLIMISEGCAD);

           CARREGA_PERIFORN(C_OPLOG.CDFILIOPELOG, C_OPLOG.CDFORNECED, C_ITOPLOG.DTPROGENTAF - V_NRDIASEG, V_DTNEWENTAF);

           SELECT
              MAX(CALECOMP.DTENTREGA)
           INTO
              V_DTENTREGA
           FROM
              CALECOMP
           WHERE
              CALECOMP.CDFILIAL   =  C_OPLOG.CDFILIOPELOG AND
              CALECOMP.CDPERIENTR =  V_CDPERIENTR         AND
              CALECOMP.DTENTREGA  <= V_DTNEWENTAF;

           IF V_DTENTREGA IS NOT NULL THEN
              V_DTNEWENTAF := V_DTENTREGA;
           END IF;

           V_QTPROGENTAF := C_ITOPLOG.QTPROGENTAF;

           IF V_IDUTEMPENHAF = 'S' THEN
              SELECT
                 DECODE(MAX(VRARREDEMPE), NULL, 0, MAX(VRARREDEMPE)) INTO V_VRARREDEMPE
              FROM
                 PRODFORNCOMP
              WHERE
                 CDPRODCOMPL = C_ITOPLOG.CDPRODUTO AND
                 CDFORNECED  = C_OPLOG.CDFORNECED;

              IF (MOD(V_QTPROGENTAF, V_VRARREDEMPE) <> 0) AND V_VRARREDEMPE > 0 THEN
                 V_QTPROGENTAF := CEIL(V_QTPROGENTAF / V_VRARREDEMPE) * V_VRARREDEMPE;
              END IF;
           END IF;


           IF (V_ITEMAUTF_ANTERIOR <>  C_OPLOG.CDFILDEST||C_OPLOG.NRAUTOFORN||C_OPLOG.SEPARA_IMPOSTO) THEN
              IF (V_ITEMANTERIOR = C_OPLOG.CDFILIOPELOG   ||
                                   C_OPLOG.CDOPERADOR     ||
                                   C_OPLOG.CDFORNECED     ||
                                   C_OPLOG.CDEMPRESA      ||
                                   C_OPLOG.SEPARA_IMPOSTO ||
                                   C_OPLOG.IDTPFORPGTAF   ||
                                   C_OPLOG.CDTIPCOB       ||
                                   C_OPLOG.IDTIPOFRETAF   ||
                                   C_OPLOG.CDFORMPGTO     ||
                                   C_OPLOG.NRPARCPGTOAF   ||
                                   C_OPLOG.NRDIAPGFIXAF   ||
                                   C_OPLOG.IDUTDIAPGTAF   ||
                                   C_OPLOG.IDTIPOEMITAF   ||
                                   C_OPLOG.IDAFPRODWEB) AND (C_OPLOG.DTENTRAPUT IS NOT NULL)
                                   AND (V_ITEMAUTF_ANT = C_OPLOG.SEPARA_IMPOSTO) THEN
                 V_NRAUTOFORN := NULL;
                 SELECT
                    MAX(AUTOFORNE.NRAUTOFORN)
                 INTO
                    V_NRAUTOFORN
                 FROM
                    ITEMAUTF,
                    AUTOFORNE
                 WHERE
                    AUTOFORNE.CDFILDEST                = C_OPLOG.CDFILIOPELOG          AND
                    AUTOFORNE.CDFILLANC                = P_CDFILLANC                   AND
                    AUTOFORNE.CDFORNECED               = C_OPLOG.CDFORNECED            AND
                    AUTOFORNE.CDEMPRESA                = C_OPLOG.CDEMPRESA             AND
                    NVL(AUTOFORNE.IDTPFORPGTAF, '' )  = NVL(C_OPLOG.IDTPFORPGTAF,'') AND
                    NVL(AUTOFORNE.CDTIPCOB,     '' )  = NVL(C_OPLOG.CDTIPCOB,    '') AND
                    NVL(AUTOFORNE.IDTIPOFRETAF, '' )  = NVL(C_OPLOG.IDTIPOFRETAF,'') AND
                    NVL(AUTOFORNE.CDFORMPGTO,   '' )  = NVL(C_OPLOG.CDFORMPGTO,  '') AND
                    NVL(AUTOFORNE.NRPARCPGTOAF, 0   )  = NVL(C_OPLOG.NRPARCPGTOAF, 0 ) AND
                    NVL(AUTOFORNE.NRDIAPGFIXAF, 0   )  = NVL(C_OPLOG.NRDIAPGFIXAF, 0 ) AND
                    NVL(AUTOFORNE.IDUTDIAPGTAF, '' )  = NVL(C_OPLOG.IDUTDIAPGTAF,'') AND
                    NVL(AUTOFORNE.IDTIPOEMITAF, '' )  = NVL(C_OPLOG.IDTIPOEMITAF,'') AND
                    NVL(AUTOFORNE.IDAFPRODWEB,  '' )  = NVL(C_OPLOG.IDAFPRODWEB, '') AND
                    AUTOFORNE.CDFILDEST                = ITEMAUTF.CDFILDEST            AND
                    AUTOFORNE.CDFILLANC                = ITEMAUTF.CDFILLANC            AND
                    AUTOFORNE.NRAUTOFORN               = ITEMAUTF.NRAUTOFORN           AND
                    AUTOFORNE.NRSEQAPURAF              = V_NRSEQAPUR                   AND
                    ITEMAUTF.DTPROGENTAF               = V_DTNEWENTAF;
                 IF V_NRAUTOFORN IS NOT NULL THEN
                    UPDATE AUTOFORNE
                    SET CDFILDESTCON = C_OPLOG.CDFILIOPELOG,
                        CDFILLANCCON = P_CDFILLANC,
                        NRAUTOFORCON = V_NRAUTOFORN,
                        IDAFOPERLOG  = '2'
                    WHERE
                       CDFILDEST     = C_OPLOG.CDFILDEST  AND
                       CDFILLANC     = P_CDFILLANC        AND
                       NRAUTOFORN    = C_OPLOG.NRAUTOFORN;

                    UPDATE ITEMAUTF
                    SET CDFILDESTOL  = C_OPLOG.CDFILIOPELOG,
                        CDFILLANCOL  = P_CDFILLANC,
                        NRAUTOFORNOL = V_NRAUTOFORN
                    WHERE
                       CDFILDEST     = C_OPLOG.CDFILDEST       AND
                       CDFILLANC     = P_CDFILLANC             AND
                       NRAUTOFORN    = C_OPLOG.NRAUTOFORN      AND
                       CDPRODUTO     = C_ITOPLOG.CDPRODITEMAF  AND
                       CDMARCA       = C_ITOPLOG.CDMARCAITEMAF AND
                       DTPROGENTAF   = C_ITOPLOG.DTPROGENTAF;

                    UPDATE ITEMAUTF
                    SET QTPROGENTAF = QTPROGENTAF + V_QTPROGENTAF
                    WHERE
                       CDFILDEST   = C_OPLOG.CDFILIOPELOG  AND
                       CDFILLANC   = P_CDFILLANC           AND
                       NRAUTOFORN  = V_NRAUTOFORN          AND
                       CDPRODUTO   = C_ITOPLOG.CDPRODUTO   AND
                       CDMARCA     = C_ITOPLOG.CDMARCA     AND
                       DTPROGENTAF = V_DTNEWENTAF;
                    IF SQL%NOTFOUND THEN
                      INSERT INTO ITEMAUTF
                         (CDFILDEST,    CDFILLANC,   NRAUTOFORN,  CDMARCA,
                          CDPRODUTO,    DTPROGENTAF, CDSEGMARCA,  VRPREUNIAF,
                          VRPERDESAF,   TXOBSITMAF,  VRDESCITMAF, QTPROGENTAF,
                          DTENTRITMSOL)
                      VALUES
                         (C_OPLOG.CDFILIOPELOG,  P_CDFILLANC,          V_NRAUTOFORN,          C_ITOPLOG.CDMARCA,
                          C_ITOPLOG.CDPRODUTO,   V_DTNEWENTAF,         C_ITOPLOG.CDSEGMARCA,  C_ITOPLOG.VRPREUNIAF,
                          C_ITOPLOG.VRPERDESAF,  C_ITOPLOG.TXOBSITMAF, C_ITOPLOG.VRDESCITMAF, V_QTPROGENTAF,
                          C_ITOPLOG.DTPROGENTAF);
                    END IF;
                    -- GERA-PARCELAS
                    UPDATE ITEMAUTF
                    SET ITEMAUTF.NRPARCITMAF = (SELECT
                                                   LPAD(TO_CHAR(COUNT(DISTINCT ITEM.DTPROGENTAF)),2,'0')
                                                FROM ITEMAUTF ITEM
                                                WHERE
                                                 (ITEM.CDFILDEST   = C_OPLOG.CDFILIOPELOG)  AND
                                                 (ITEM.CDFILLANC   = P_CDFILLANC)           AND
                                                 (ITEM.NRAUTOFORN  = V_NRAUTOFORN)          AND
                                                 (ITEM.DTPROGENTAF <= ITEMAUTF.DTPROGENTAF))
                    WHERE
                       (ITEMAUTF.CDFILDEST  = C_OPLOG.CDFILIOPELOG) AND
                       (ITEMAUTF.CDFILLANC  = P_CDFILLANC) AND
                       (ITEMAUTF.NRAUTOFORN = V_NRAUTOFORN);

                    SELECT MIN(CDINSCESTA) INTO V_CDINSCESTA
                    FROM INSCRESTAD
                    WHERE (CDEMPRESA = C_OPLOG.CDEMPRESA);

                    SELECT MIN(DTPROGENTAF) INTO V_DTPROGENTAF
                    FROM ITEMAUTF
                    WHERE (CDFILDEST  = C_OPLOG.CDFILIOPELOG)  AND
                          (CDFILLANC  = P_CDFILLANC)  AND
                          (NRAUTOFORN = V_NRAUTOFORN);

                    IMPOSTO_ITEMAF(C_OPLOG.CDEMPRESA,
                                   V_CDINSCESTA,
                                   C_OPLOG.CDFORNECED,
                                   C_OPLOG.CDFILIOPELOG,
                                   P_CDFILLANC,
                                   V_NRAUTOFORN,
                                   V_DTPROGENTAF);

                    -- qryValor_AF
                    SELECT
                       SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
                       SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * NVL(ITEMAUTF.VRPERDESAF, 0)) / 100)
                       INTO V_VRPRODUTO, V_VRDESCONTO
                    FROM
                       ITEMAUTF
                    WHERE
                       (ITEMAUTF.CDFILDEST  = C_OPLOG.CDFILIOPELOG) AND
                       (ITEMAUTF.CDFILLANC  = P_CDFILLANC) AND
                       (ITEMAUTF.NRAUTOFORN = V_NRAUTOFORN);

                    SELECT
                       NVL(SUM(IMPITMAF.VRADIMPAF), 0) INTO V_VRIMPOSTO
                    FROM
                       IMPITMAF,
                       ITEMAUTF
                    WHERE
                       (IMPITMAF.CDFILDEST   = C_OPLOG.CDFILIOPELOG) AND
                       (IMPITMAF.CDFILLANC   = P_CDFILLANC)          AND
                       (IMPITMAF.NRAUTOFORN  = V_NRAUTOFORN)         AND
                       (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)   AND
                       (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)   AND
                       (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)  AND
                       (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)   AND
                       (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)     AND
                       (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF);

                    UPDATE AUTOFORNE
                    SET VRTOTALAF = V_VRPRODUTO - V_VRDESCONTO + V_VRIMPOSTO
                    WHERE
                       (CDFILDEST   = C_OPLOG.CDFILIOPELOG) AND
                       (CDFILLANC   = P_CDFILLANC) AND
                       (NRAUTOFORN  = V_NRAUTOFORN);
                 ELSE
                    IF C_ITOPLOG.SEPARA_IMPOSTO_IT = 'X' THEN
                       SELECT
                          NVL(MAX(NRAUTOFORCON), V_NOVOCODIGO)
                       INTO
                          V_NRAUTFOROL
                       FROM
                          AUTOFORNE
                       WHERE
                          CDFILDEST      = C_OPLOG.CDFILDEST       AND
                          CDFILLANC      = P_CDFILLANC             AND
                          NRAUTOFORN     = C_OPLOG.NRAUTOFORN;
                    ELSE
                       SELECT
                          NVL(MAX(NRAUTOFORCON), V_NOVOCODIGO)
                       INTO
                          V_NRAUTFOROL
                       FROM
                          ITEMAUTF,
                          AUTOFORNE
                       WHERE
                          AUTOFORNE.CDFILDEST  = C_OPLOG.CDFILDEST   AND
                          AUTOFORNE.CDFILLANC  = P_CDFILLANC         AND
                          AUTOFORNE.NRAUTOFORN = C_OPLOG.NRAUTOFORN  AND
                          AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                          AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                          AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                          SUBSTR(SEPARA_AF_IMPOSTO_FUN(ITEMAUTF.CDFILDEST,
                                                       ITEMAUTF.CDFILLANC,
                                                       ITEMAUTF.NRAUTOFORN,
                                                       ITEMAUTF.CDPRODUTO,
                                                       ITEMAUTF.CDMARCA,
                                                       ITEMAUTF.DTPROGENTAF), 1, 2) = C_ITOPLOG.SEPARA_IMPOSTO_IT;
                    END IF;
                    SELECT
                       COUNT(*)
                    INTO
                       V_COUNT_AF
                    FROM
                       ITEMAUTF
                    WHERE
                       CDFILDEST    = C_OPLOG.CDFILIOPELOG AND
                       CDFILLANC    = P_CDFILLANC          AND
                       NRAUTOFORN   = V_NRAUTFOROL         AND
                       DTPROGENTAF <> V_DTNEWENTAF;
                    IF V_COUNT_AF > 0 THEN
                       IF V_ANTCODIGO <> ' ' THEN
                          -- GERA-PARCELAS
                          UPDATE ITEMAUTF
                          SET ITEMAUTF.NRPARCITMAF = (SELECT
                                                         LPAD(TO_CHAR(COUNT(DISTINCT ITEM.DTPROGENTAF)),2,'0')
                                                      FROM ITEMAUTF ITEM
                                                      WHERE
                                                       (ITEM.CDFILDEST   = V_ANTCDFILDEST) AND
                                                       (ITEM.CDFILLANC   = P_CDFILLANC)    AND
                                                       (ITEM.NRAUTOFORN  = V_ANTCODIGO)    AND
                                                       (ITEM.DTPROGENTAF <= ITEMAUTF.DTPROGENTAF))
                          WHERE
                             (ITEMAUTF.CDFILDEST  = V_ANTCDFILDEST) AND
                             (ITEMAUTF.CDFILLANC  = P_CDFILLANC) AND
                             (ITEMAUTF.NRAUTOFORN = V_ANTCODIGO);

                          SELECT MIN(CDINSCESTA) INTO V_CDINSCESTA
                          FROM INSCRESTAD
                          WHERE (CDEMPRESA = V_ANTCDEMPRESA);

                          SELECT MIN(DTPROGENTAF) INTO V_DTPROGENTAF
                          FROM ITEMAUTF
                          WHERE (CDFILDEST  = V_ANTCDFILDEST)  AND
                                (CDFILLANC  = V_ANTCDFILLANC)  AND
                                (NRAUTOFORN = V_ANTCODIGO);

                          IMPOSTO_ITEMAF(V_ANTCDEMPRESA,
                                         V_CDINSCESTA,
                                         V_ANTCDFORNECED,
                                         V_ANTCDFILDEST,
                                         P_CDFILLANC,
                                         V_ANTCODIGO,
                                         V_DTPROGENTAF);

                          -- qryValor_AF

                          SELECT
                             SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
                             SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * NVL(ITEMAUTF.VRPERDESAF, 0)) / 100)
                             INTO V_VRPRODUTO, V_VRDESCONTO
                          FROM
                             ITEMAUTF
                          WHERE
                             (ITEMAUTF.CDFILDEST  = V_ANTCDFILDEST) AND
                             (ITEMAUTF.CDFILLANC  = V_ANTCDFILLANC) AND
                             (ITEMAUTF.NRAUTOFORN = V_ANTCODIGO);

                          SELECT
                             NVL(SUM(IMPITMAF.VRADIMPAF), 0) INTO V_VRIMPOSTO
                          FROM
                             IMPITMAF,
                             ITEMAUTF
                          WHERE
                             (IMPITMAF.CDFILDEST   = V_ANTCDFILDEST)       AND
                             (IMPITMAF.CDFILLANC   = V_ANTCDFILLANC)       AND
                             (IMPITMAF.NRAUTOFORN  = V_ANTCODIGO)          AND
                             (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)   AND
                             (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)   AND
                             (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)  AND
                             (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)   AND
                             (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)     AND
                             (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF);

                          UPDATE AUTOFORNE
                          SET VRTOTALAF = V_VRPRODUTO - V_VRDESCONTO + V_VRIMPOSTO
                          WHERE
                             (CDFILDEST   = V_ANTCDFILDEST) AND
                             (CDFILLANC   = V_ANTCDFILLANC) AND
                             (NRAUTOFORN  = V_ANTCODIGO);
                       END IF;
                       NOVO_CODIGO('AUTOFORNE'||C_OPLOG.CDFILIOPELOG || P_CDFILLANC, V_NOVOCODIGO, 1);
                       V_NOVOCODIGO := SUBSTR(V_NOVOCODIGO, 11, 10);

                       V_ANTCDFILDEST  := C_OPLOG.CDFILIOPELOG;
                       V_ANTCODIGO     := V_NOVOCODIGO;
                       V_ANTCDEMPRESA  := C_OPLOG.CDEMPRESA;
                       V_ANTCDFORNECED := C_OPLOG.CDFORNECED;

                       INSERT INTO AUTOFORNE
                        (CDFILDEST,    CDFILLANC,    NRAUTOFORN,   CDOPERADOR,   DTAUTOFORN,
                         IDTPFORPGTAF, IDTIPOEMITAF, IDTIPOFRETAF, NRPARCPGTOAF, NRDIAPGFIXAF,
                         IDUTDIAPGTAF, CDTIPCOB,     CDEMPRESA,    CDFORMPGTO,   CDFORNECED,
                         NRSEQAPURAF,  IDAFPRODWEB,  IDAFOPERLOG,  IDTIPOLANCAF, IDBAIXAAF,
                         IDAFCONS)
                       VALUES
                        (C_OPLOG.CDFILIOPELOG, P_CDFILLANC,          V_NOVOCODIGO,         C_OPLOG.CDOPERADOR,         P_DTAUTOFORN,
                         C_OPLOG.IDTPFORPGTAF, C_OPLOG.IDTIPOEMITAF, C_OPLOG.IDTIPOFRETAF, C_OPLOG.NRPARCPGTOAF, C_OPLOG.NRDIAPGFIXAF,
                         C_OPLOG.IDUTDIAPGTAF, C_OPLOG.CDTIPCOB,     C_OPLOG.CDEMPRESA,    C_OPLOG.CDFORMPGTO,   C_OPLOG.CDFORNECED,
                         V_NRSEQAPUR,          C_OPLOG.IDAFPRODWEB,  '1',                  'A',                  '6',
                         'N');

                       IF C_OPLOG.NRDIASPGTOAF IS NOT NULL THEN
                         INSERT INTO PRAZOPGTAF
                          (CDFILDEST, CDFILLANC, NRAUTOFORN,  NRDIASPGTOAF, VRPERCPGTOAF)
                         VALUES
                          (C_OPLOG.CDFILIOPELOG, P_CDFILLANC, V_NOVOCODIGO,
                           C_OPLOG.NRDIASPGTOAF, C_OPLOG.VRPERCPGTOAF);
                       END IF;
                       V_NRAUTFOROL := V_NOVOCODIGO;
                    END IF;
                    UPDATE AUTOFORNE
                    SET CDFILDESTCON = C_OPLOG.CDFILIOPELOG,
                        CDFILLANCCON = P_CDFILLANC,
                        NRAUTOFORCON = V_NRAUTFOROL,
                        IDAFOPERLOG  = '2'
                    WHERE
                       CDFILDEST  = C_OPLOG.CDFILDEST   AND
                       CDFILLANC  = P_CDFILLANC         AND
                       NRAUTOFORN = C_OPLOG.NRAUTOFORN;

                    UPDATE ITEMAUTF
                    SET CDFILDESTOL  = C_OPLOG.CDFILIOPELOG,
                        CDFILLANCOL  = P_CDFILLANC,
                        NRAUTOFORNOL = V_NRAUTFOROL
                    WHERE
                       CDFILDEST     = C_OPLOG.CDFILDEST       AND
                       CDFILLANC     = P_CDFILLANC             AND
                       NRAUTOFORN    = C_OPLOG.NRAUTOFORN      AND
                       CDPRODUTO     = C_ITOPLOG.CDPRODITEMAF  AND
                       CDMARCA       = C_ITOPLOG.CDMARCAITEMAF AND
                       DTPROGENTAF   = C_ITOPLOG.DTPROGENTAF;
                    UPDATE ITEMAUTF
                    SET QTPROGENTAF = QTPROGENTAF + V_QTPROGENTAF
                    WHERE
                       CDFILDEST   = C_OPLOG.CDFILIOPELOG  AND
                       CDFILLANC   = P_CDFILLANC           AND
                       NRAUTOFORN  = V_NRAUTFOROL          AND
                       CDPRODUTO   = C_ITOPLOG.CDPRODUTO   AND
                       CDMARCA     = C_ITOPLOG.CDMARCA     AND
                       DTPROGENTAF = V_DTNEWENTAF;
                    IF SQL%NOTFOUND THEN
                      INSERT INTO ITEMAUTF
                         (CDFILDEST,    CDFILLANC,   NRAUTOFORN,  CDMARCA,
                          CDPRODUTO,    DTPROGENTAF, CDSEGMARCA,  VRPREUNIAF,
                          VRPERDESAF,   TXOBSITMAF,  VRDESCITMAF, QTPROGENTAF,
                          DTENTRITMSOL)
                      VALUES
                         (C_OPLOG.CDFILIOPELOG,  P_CDFILLANC,          V_NRAUTFOROL,          C_ITOPLOG.CDMARCA,
                          C_ITOPLOG.CDPRODUTO,   V_DTNEWENTAF,         C_ITOPLOG.CDSEGMARCA,  C_ITOPLOG.VRPREUNIAF,
                          C_ITOPLOG.VRPERDESAF,  C_ITOPLOG.TXOBSITMAF, C_ITOPLOG.VRDESCITMAF, V_QTPROGENTAF,
                          C_ITOPLOG.DTPROGENTAF);
                    END IF;
                 END IF;
              ELSE
                 IF C_ITOPLOG.SEPARA_IMPOSTO_IT = 'X' THEN
                    SELECT
                       NVL(MAX(NRAUTOFORCON), V_NOVOCODIGO)
                    INTO
                       V_NRAUTFOROL
                    FROM
                       AUTOFORNE
                    WHERE
                       CDFILDEST      = C_OPLOG.CDFILDEST       AND
                       CDFILLANC      = P_CDFILLANC             AND
                       NRAUTOFORN     = C_OPLOG.NRAUTOFORN;
                 ELSE
                    SELECT
                       NVL(MAX(NRAUTOFORCON), V_NOVOCODIGO)
                    INTO
                       V_NRAUTFOROL
                    FROM
                       ITEMAUTF,
                       AUTOFORNE
                    WHERE
                       AUTOFORNE.CDFILDEST  = C_OPLOG.CDFILDEST   AND
                       AUTOFORNE.CDFILLANC  = P_CDFILLANC         AND
                       AUTOFORNE.NRAUTOFORN = C_OPLOG.NRAUTOFORN  AND
                       AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                       AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                       AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                       SUBSTR(SEPARA_AF_IMPOSTO_FUN(ITEMAUTF.CDFILDEST,
                                                    ITEMAUTF.CDFILLANC,
                                                    ITEMAUTF.NRAUTOFORN,
                                                    ITEMAUTF.CDPRODUTO,
                                                    ITEMAUTF.CDMARCA,
                                                    ITEMAUTF.DTPROGENTAF), 1, 2) = C_ITOPLOG.SEPARA_IMPOSTO_IT;
                 END IF;
                 UPDATE AUTOFORNE
                 SET CDFILDESTCON = C_OPLOG.CDFILIOPELOG,
                     CDFILLANCCON = P_CDFILLANC,
                     NRAUTOFORCON = V_NRAUTFOROL,
                     IDAFOPERLOG  = '2'
                 WHERE
                    CDFILDEST  = C_OPLOG.CDFILDEST   AND
                    CDFILLANC  = P_CDFILLANC         AND
                    NRAUTOFORN = C_OPLOG.NRAUTOFORN;

                 UPDATE ITEMAUTF
                 SET CDFILDESTOL  = C_OPLOG.CDFILIOPELOG,
                     CDFILLANCOL  = P_CDFILLANC,
                     NRAUTOFORNOL = V_NRAUTFOROL
                 WHERE
                    CDFILDEST     = C_OPLOG.CDFILDEST       AND
                    CDFILLANC     = P_CDFILLANC             AND
                    NRAUTOFORN    = C_OPLOG.NRAUTOFORN      AND
                    CDPRODUTO     = C_ITOPLOG.CDPRODITEMAF  AND
                    CDMARCA       = C_ITOPLOG.CDMARCAITEMAF AND
                    DTPROGENTAF   = C_ITOPLOG.DTPROGENTAF;

                 UPDATE ITEMAUTF
                 SET QTPROGENTAF = QTPROGENTAF + V_QTPROGENTAF
                 WHERE
                    CDFILDEST   = C_OPLOG.CDFILIOPELOG  AND
                    CDFILLANC   = P_CDFILLANC           AND
                    NRAUTOFORN  = V_NRAUTFOROL          AND
                    CDPRODUTO   = C_ITOPLOG.CDPRODUTO   AND
                    CDMARCA     = C_ITOPLOG.CDMARCA     AND
                    DTPROGENTAF = V_DTNEWENTAF;

                 IF SQL%NOTFOUND THEN
                   INSERT INTO ITEMAUTF
                      (CDFILDEST,    CDFILLANC,   NRAUTOFORN,  CDMARCA,
                       CDPRODUTO,    DTPROGENTAF, CDSEGMARCA,  VRPREUNIAF,
                       VRPERDESAF,   TXOBSITMAF,  VRDESCITMAF, QTPROGENTAF,
                       DTENTRITMSOL)
                   VALUES
                      (C_OPLOG.CDFILIOPELOG,  P_CDFILLANC,          V_NRAUTFOROL,          C_ITOPLOG.CDMARCA,
                       C_ITOPLOG.CDPRODUTO,   V_DTNEWENTAF,         C_ITOPLOG.CDSEGMARCA,  C_ITOPLOG.VRPREUNIAF,
                       C_ITOPLOG.VRPERDESAF,  C_ITOPLOG.TXOBSITMAF, C_ITOPLOG.VRDESCITMAF, V_QTPROGENTAF,
                       C_ITOPLOG.DTPROGENTAF);
                 END IF;
              END IF;
           END IF;
        END IF;
     END LOOP;
     V_ITEMAUTF_ANTERIOR := C_OPLOG.CDFILDEST||C_OPLOG.NRAUTOFORN||C_OPLOG.SEPARA_IMPOSTO;
     V_ITEMAUTF_ANT      := C_OPLOG.SEPARA_IMPOSTO;
   END LOOP;
/*   LTIMO REGISTRO DE AF*/
   -- GERA-PARCELAS
   UPDATE ITEMAUTF
   SET ITEMAUTF.NRPARCITMAF = (SELECT
                                  LPAD(TO_CHAR(COUNT(DISTINCT ITEM.DTPROGENTAF)),2,'0')
                               FROM ITEMAUTF ITEM
                               WHERE
                                (ITEM.CDFILDEST   = V_ANTCDFILDEST) AND
                                (ITEM.CDFILLANC   = P_CDFILLANC)    AND
                                (ITEM.NRAUTOFORN  = V_ANTCODIGO)    AND
                                (ITEM.DTPROGENTAF <= ITEMAUTF.DTPROGENTAF))
   WHERE
      (ITEMAUTF.CDFILDEST  = V_ANTCDFILDEST) AND
      (ITEMAUTF.CDFILLANC  = P_CDFILLANC) AND
      (ITEMAUTF.NRAUTOFORN = V_ANTCODIGO);

   SELECT MIN(CDINSCESTA) INTO V_CDINSCESTA
   FROM INSCRESTAD
   WHERE (CDEMPRESA = V_ANTCDEMPRESA);

   SELECT MIN(DTPROGENTAF) INTO V_DTPROGENTAF
   FROM ITEMAUTF
   WHERE (CDFILDEST  = V_ANTCDFILDEST)  AND
         (CDFILLANC  = V_ANTCDFILLANC)  AND
         (NRAUTOFORN = V_ANTCODIGO);

   IMPOSTO_ITEMAF(V_ANTCDEMPRESA,
                  V_CDINSCESTA,
                  V_ANTCDFORNECED,
                  V_ANTCDFILDEST,
                  P_CDFILLANC,
                  V_ANTCODIGO,
                  V_DTPROGENTAF);

   -- qryValor_AF

   SELECT
      SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
      SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * NVL(ITEMAUTF.VRPERDESAF, 0)) / 100)
      INTO V_VRPRODUTO, V_VRDESCONTO
   FROM
      ITEMAUTF
   WHERE
      (ITEMAUTF.CDFILDEST  = V_ANTCDFILDEST) AND
      (ITEMAUTF.CDFILLANC  = V_ANTCDFILLANC) AND
      (ITEMAUTF.NRAUTOFORN = V_ANTCODIGO);

   SELECT
      NVL(SUM(IMPITMAF.VRADIMPAF), 0) INTO V_VRIMPOSTO
   FROM
      IMPITMAF,
      ITEMAUTF
   WHERE
      (IMPITMAF.CDFILDEST   = V_ANTCDFILDEST)       AND
      (IMPITMAF.CDFILLANC   = V_ANTCDFILLANC)       AND
      (IMPITMAF.NRAUTOFORN  = V_ANTCODIGO)          AND
      (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)   AND
      (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)   AND
      (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)  AND
      (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)   AND
      (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)     AND
      (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF);

   UPDATE AUTOFORNE
   SET VRTOTALAF = V_VRPRODUTO - V_VRDESCONTO + V_VRIMPOSTO
   WHERE
      (CDFILDEST   = V_ANTCDFILDEST) AND
      (CDFILLANC   = V_ANTCDFILLANC) AND
      (NRAUTOFORN  = V_ANTCODIGO);

   DELETE FROM AUTOFORNE
   WHERE
      AUTOFORNE.CDFILLANC   = P_CDFILLANC AND
      AUTOFORNE.NRSEQAPURAF = V_NRSEQAPUR AND
      NOT EXISTS (SELECT '1'
                  FROM ITEMAUTF
                  WHERE AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST AND
                        AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC AND
                        AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN);
   SELECT
      COUNT(*)
   INTO
      V_COUNT_APUR
   FROM
      LISTA
   WHERE
      LISTA.NRLISTA = P_NRSEQAPUR;

   IF V_COUNT_APUR > 1 THEN
      UPDATE APURPRECO
      SET NRAPURCONS = V_NRSEQAPUR
      WHERE
         EXISTS (SELECT '1'
                 FROM
                    LISTA
                 WHERE
                    APURPRECO.CDFILCENTCMP  = P_CDCENTCMP AND
                    LISTA.NRLISTA = P_NRSEQAPUR           AND
                    LISTA.CDLISTA = NRAPURPREC);
   END IF;

   UPDATE APURPRECO
   SET IDSITAPUPREC = '5'
   WHERE
      CDFILCENTCMP = P_CDCENTCMP AND
      NRAPURPREC   = V_NRSEQAPUR;

   P_NRSEQAPURCON := V_NRSEQAPUR;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CONSOLIDA_AF','4.07.037'); END;
/
